/*
 *  A FLAC decoder plugin for the Beep Media Player
 *  Copyright (C) 2005 Ralf Ertzinger
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "flac.h"
#include <libgnomevfs/gnome-vfs.h>

/*
 * WARNING: dirty hack ahead.
 */

struct _VFSFile {
    GnomeVFSHandle* handle;
};

/* === */

size_t vfs_fsize(struct _VFSFile* file) {

    GnomeVFSFileInfo info;
    GnomeVFSResult result;

    _ENTER;

    if (GNOME_VFS_OK != (result =
        gnome_vfs_get_file_info_from_handle(file->handle, &info, GNOME_VFS_FILE_INFO_DEFAULT))) {

        _ERROR("Could not get file statistics!");
        _ERROR("%s", gnome_vfs_result_to_string(result));
        _LEAVE -1;
    }

    /*
     * Does the structure contain the information we seek?
     */

    if (0 == (info.valid_fields & GNOME_VFS_FILE_INFO_FIELDS_SIZE)) {
        /*
         * No, it does not. Shucks. Return 0 as size.
         */
        _DEBUG("Structure does not contain a valid size!");
        _LEAVE 0;
    }

    /*
     * All seems well.
     */
    _DEBUG("File size is %lld", info.size);
    _LEAVE info.size;
}

/* --- */

gboolean vfs_feof(struct _VFSFile* file) {

    /*
     * This not exactly elegant, but I know of no other way to
     * do this....
     */

    _ENTER;

    if (vfs_ftell(file) == vfs_fsize(file)) {
        /* EOF */
        _DEBUG("At end of file");
        _LEAVE TRUE;
    } else {
        /* Not EOF */
        _DEBUG("Not at end of file");
        _LEAVE FALSE;
    }
}
